<Project>

	<PropertyGroup>
		<BuildProjectNamespace>Cloudburst.BuildTools.Generic</BuildProjectNamespace>
		<TaskNamespace>$(BuildProjectNamespace).Tasks</TaskNamespace>
		<TaskAssembly Condition="'$(CloudburstTaskAssemblyLocation)' == ''">$(MSBuildThisFileDirectory)..\tasks\netstandard2.0\$(BuildProjectNamespace).dll</TaskAssembly>
		<TaskAssembly Condition="'$(CloudburstTaskAssemblyLocation)' != '' AND Exists('$(CloudburstTaskAssemblyLocation)')">$(CloudburstTaskAssemblyLocation)\$(BuildProjectNamespace).dll</TaskAssembly>
	</PropertyGroup>

	<UsingTask TaskName="$(TaskNamespace).ProjectInformation" AssemblyFile="$(TaskAssembly)" />

	<Target Name="CloudburstGenericProjectInformation" BeforeTargets="BeforeBuild">
		<PropertyGroup>
			<ProjectDetailsJson Condition="'$(ProjectDetailsJson)' == ''">$(ProjectDir)..\ProjectDetails.json</ProjectDetailsJson>
			<ProjectLicenseFile Condition="'$(ProjectLicenseFile)' == ''">$(ProjectDir)..\LICENSE</ProjectLicenseFile>
		</PropertyGroup>

		<ProjectInformation JsonFile="$(ProjectDetailsJson)">
			<Output TaskParameter="Details" ItemName="ProjectDetails" />
			<Output TaskParameter="Version" ItemName="ProjectVersion" />
		</ProjectInformation>

		<Error Text="Project Namespace is not set." Condition="'%(ProjectDetails.Namespace)' == ''" />
		<Error Text="Project Title is not set." Condition="'%(ProjectDetails.Title)' == ''" />
		<Error Text="Project Description is not set." Condition="'%(ProjectDetails.Description)' == ''" />

		<Message Text="Project Namespace: %(ProjectDetails.Namespace)" />
		<Message Text="Project Title: %(ProjectDetails.Title)" />
		<Message Text="Project Description: %(ProjectDetails.Description)" />
		<Message Text="Project Directory: $(ProjectDir)" />
		<Message Text="Project Details Json: $(ProjectDetailsJson)" />
		<Message Text="Project License File: $(ProjectLicenseFile)" />
		<Message Text="Project Version: %(ProjectVersion.Major).%(ProjectVersion.Minor).%(ProjectVersion.Patch)" />

		<PropertyGroup>
			<Product>%(ProjectDetails.Title)</Product>
			<Title>%(ProjectDetails.Title)</Title>
			<Description>%(ProjectDetails.Description)</Description>
			<Copyright>%(ProjectDetails.ProjectCopyright)</Copyright>
			<Authors>%(ProjectDetails.ProjectAuthor)</Authors>
		</PropertyGroup>

		<PropertyGroup>
			<FileVersion>%(ProjectVersion.Major).%(ProjectVersion.Minor).%(ProjectVersion.Patch).%(ProjectVersion.Build)</FileVersion>
			<AssemblyVersion>%(ProjectVersion.Major).%(ProjectVersion.Minor).%(ProjectVersion.Patch).%(ProjectVersion.Build)</AssemblyVersion>
		</PropertyGroup>

		<PropertyGroup Condition="'$(Configuration)' == 'Release'">
			<Version>%(ProjectVersion.Major).%(ProjectVersion.Minor).%(ProjectVersion.Patch)</Version>
			<ApplicationVersion>%(ProjectVersion.Major).%(ProjectVersion.Minor).%(ProjectVersion.Patch)</ApplicationVersion>
			<InformationalVersion>%(ProjectVersion.Major).%(ProjectVersion.Minor).%(ProjectVersion.Patch)</InformationalVersion>
			<ProductVersion>%(ProjectVersion.Major).%(ProjectVersion.Minor).%(ProjectVersion.Patch)</ProductVersion>
		</PropertyGroup>

		<PropertyGroup Condition="'$(Configuration)' == 'Debug'">
			<Version>%(ProjectVersion.Major).%(ProjectVersion.Minor).%(ProjectVersion.Patch)-Build.%(ProjectVersion.Build)</Version>
			<ApplicationVersion>%(ProjectVersion.Major).%(ProjectVersion.Minor).%(ProjectVersion.Patch)-Build.%(ProjectVersion.Build)</ApplicationVersion>
			<InformationalVersion>%(ProjectVersion.Major).%(ProjectVersion.Minor).%(ProjectVersion.Patch)-Build.%(ProjectVersion.Build)</InformationalVersion>
			<ProductVersion>%(ProjectVersion.Major).%(ProjectVersion.Minor).%(ProjectVersion.Patch)-Build.%(ProjectVersion.Build)</ProductVersion>
		</PropertyGroup>

		<ItemGroup Condition="Exists('$(ProjectDir)ProjectDetails.json')">
			<Content Include="ProjectDetails.json">
				<ExcludeFromSingleFile>true</ExcludeFromSingleFile>
				<CopyToOutputDirectory>Never</CopyToOutputDirectory>
				<CopyToPublishDirectory>Never</CopyToPublishDirectory>
			</Content>
		</ItemGroup>

	</Target>

</Project>
